structure Count =
struct

    (* break a string into a list of words*)
    fun words (s : string) : string list = (String.tokens Char.isSpace s)

    (* derived form: update a key if it is already there.
       
       NOTE: since this function is outside the TreeDict module, you
       can't case on the dictionary.  Instead, try to implement this by
       combining the operations from the dictionary signature (empty,
       lookup, insert).  

       *)
    fun increment (d : (string,int) TreeDict.dict, s : string) : (string,int) TreeDict.dict = 
        raise Fail "unimplemented"

    fun count (l : string list, d : (string,int) TreeDict.dict) : (string,int) TreeDict.dict = 
        raise Fail "unimplemented"



    (* for testing *)
            
    fun ioToString(x : int option) : string = 
        case x of 
            NONE => "NONE"
          | SOME y => "SOME(" ^ Int.toString y ^ ")"
                
    fun testio (s : string) (n : int option) (m : int option) : unit =
        case n = m of
            true => print ("Test " ^ s ^ " OK\n")
          | false => print ("Test " ^ s ^ " FAILED:\n    Expected: " ^ ioToString m ^ "\n    Got: " ^ ioToString n ^ "\n")
                
    fun test_count() =
        let val test_dict = count (["hi there", "how are you today", "I'm fine how are you"], TreeDict.empty)
        in 
            testio "t1" (TreeDict.lookup (String.compare, test_dict, "there")) (SOME 1);
            testio "t2" (TreeDict.lookup (String.compare, test_dict, "how")) (SOME 2);
            testio "t3" (TreeDict.lookup (String.compare, test_dict, "are")) (SOME 2);
            testio "t4" (TreeDict.lookup (String.compare, test_dict, "you")) (SOME 2);
            testio "t5" (TreeDict.lookup (String.compare, test_dict, "today")) (SOME 1);
            testio "t6" (TreeDict.lookup (String.compare, test_dict, "I'm")) (SOME 1);
            testio "t7" (TreeDict.lookup (String.compare, test_dict, "fine")) (SOME 1)
        end

end